-- rev 2

CREATE TABLE IF NOT EXISTS `_prefix_audio_video` (
    `ID` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
    `type` varchar(20) NOT NULL,
    `poster_path` longtext,
    `poster_filename` longtext,
    `width` bigint(20) UNSIGNED NOT NULL,
    `height` bigint(20) UNSIGNED NOT NULL,
    `view` varchar(255),
    `title` varchar(255) NOT NULL,
    `alt` varchar(255),
    `author_id` bigint(20) UNSIGNED NOT NULL,
    `created_on` datetime NOT NULL,
    `modified` datetime NOT NULL
) ENGINE = innodb CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE IF NOT EXISTS `_prefix_source` (
    `ID` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
    `order_no` bigint(20) UNSIGNED NOT NULL,
    `type` varchar(255) NOT NULL,
    `external_mode` boolean NOT NULL,
    `external_url` longtext,
    `upload_path` longtext,
    `upload_filename` longtext,
    `disabled` boolean NOT NULL,
    `audio_video_id` bigint(20) UNSIGNED NOT NULL,
    FOREIGN KEY (audio_video_id) REFERENCES `_prefix_audio_video`(ID)
ON UPDATE CASCADE ON DELETE CASCADE
) ENGINE = innodb CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE IF NOT EXISTS `_prefix_track` (
    `ID` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
    `order_no` bigint(20) UNSIGNED NOT NULL,
    `kind` varchar(255) NOT NULL,
    `external_mode` boolean NOT NULL,
    `external_url` longtext,
    `upload_path` longtext,
    `upload_filename` longtext,
    `srclang` text,
    `label` text,
    `disabled` boolean NOT NULL,
    `audio_video_id` bigint(20) UNSIGNED NOT NULL,
    FOREIGN KEY (audio_video_id) REFERENCES `_prefix_audio_video`(ID)
ON UPDATE CASCADE ON DELETE CASCADE
) ENGINE = innodb CHARACTER SET utf8 COLLATE utf8_general_ci;